RailwayCashBox/Controllers/BookingController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.AspNet.Identity;
using RailwayCashBox.DAL.Entities;
using RailwayCashBox.DAL.Repositories;
using RailwayCashBox.Models;

namespace RailwayCashBox.Controllers
{
	[Authorize(Roles = "user")]
	public class BookingController : Controller
	{
        private Repository db = new Repository();

		public ActionResult Orders()
		{
			return View(db.GetOrders(User.Identity.GetUserId()));
		}

		public ActionResult StartBooking(int id)
		{
			var reset = Request.UrlReferrer == null || Request.UrlReferrer.Segments.Skip(1).Take(1).FirstOrDefault() != "Booking/";
			if (reset)
				Session["BookingProgress"] = null;

			var bookingProgress = Session["BookingProgress"] as BookingProgress;
			if (bookingProgress == null || bookingProgress.TrainScheduleRecord.Id != id)
			{
				var record = db.GetTrainScheduleRecord(id);
				bookingProgress = new BookingProgress
				{
					TrainScheduleRecord = record
				};

				foreach (var t in record.SeatBookings.Where(s => s.Booked))
				{
					bookingProgress.PreviouslyBookedSeats.Add(string.Format(BookingProgress.SeatNumberFormat, t.TrainCar.Number, t.SeatNumber));
				}
			}

			Session["BookingProgress"] = bookingProgress;

			return View(bookingProgress);
		}

		public ActionResult PrebookSeat(int schedulerecordid, int carnumber, int seatid)
		{
			var bookingProgress = (BookingProgress)Session["BookingProgress"];

			bookingProgress.ChoosenSeats.Add(string.Format(BookingProgress.SeatNumberFormat, carnumber, seatid));
			bookingProgress.ChoosenSeats = bookingProgress.ChoosenSeats.OrderBy(s => s).ToList();
			return RedirectToAction("StartBooking", new { id = schedulerecordid });
		}

		public ActionResult FinishBooking()
		{
			var bookingProgress = (BookingProgress)Session["BookingProgress"];
			var order = new OrderModel
			{
				SeatsToBook = bookingProgress.ChoosenSeats,
				TrainCode = bookingProgress.TrainScheduleRecord.TrainRoute.Code,
				DepartureStationName = bookingProgress.TrainScheduleRecord.TrainRoute.StartStation.Station.Name,
				ArrivalStationName = bookingProgress.TrainScheduleRecord.TrainRoute.EndStation.Station.Name,
				DepartureDate = bookingProgress.TrainScheduleRecord.DepartureDate,
				ArrivalDate = bookingProgress.TrainScheduleRecord.ArrivalDate
			};

			var seatBookings = new List<SeatBooking>();
			foreach (var choosenSeat in bookingProgress.ChoosenSeats)
			{
				var carNumber = int.Parse(choosenSeat.Split('-').First());
				var seatNumber = int.Parse(choosenSeat.Split('-').Last());

				var booking = bookingProgress.TrainScheduleRecord.SeatBookings.First(s => s.TrainCar.Number == carNumber && s.SeatNumber == seatNumber);
				seatBookings.Add(booking);
			}

			order.TotalPrice = seatBookings.Sum(s => s.TrainCar.SeatPrice);
			return View(order);
		}

		[HttpPost]
		public ActionResult FinishBooking(OrderModel orderModel)
		{
			var bookingProgress = (BookingProgress)Session["BookingProgress"];
			var user = User.Identity.GetUserId();

			var order = new Order();

			var seatBookings = new List<SeatBooking>();
			foreach (var choosenSeat in bookingProgress.ChoosenSeats)
			{
				var carNumber = int.Parse(choosenSeat.Split('-').First());
				var seatNumber = int.Parse(choosenSeat.Split('-').Last());

				var booking = bookingProgress.TrainScheduleRecord.SeatBookings.First(s => s.TrainCar.Number == carNumber && s.SeatNumber == seatNumber);
				seatBookings.Add(booking);
			}

			order.TrainScheduleRecord = bookingProgress.TrainScheduleRecord;
			order.SeatBookings = seatBookings;
			order.TotalPrice = orderModel.TotalPrice;
			order.UserId = user;

			foreach (var seatBooking in order.SeatBookings)
			{
				seatBooking.Booked = true;
			}

			db.SaveOrder(order);

			return RedirectToAction("Orders");
		}

		public ActionResult DeleteOrder(int id)
		{
			db.DeleteOrder(id);
			return RedirectToAction("Orders");
		}

		protected override void Dispose(bool disposing)
		{
			db.Dispose();
			base.Dispose(disposing);
		}

		public ActionResult TrainRouteDetails(int id)
		{
			return RedirectToAction("Details", "TrainRoute", new {id});
		}
	}
}

RailwayCashBox/Controllers/ManagersController.cs
using System.Linq;
using System.Web.Mvc;
using RailwayCashBox.DAL.Repositories;
using RailwayCashBox.Models;

namespace RailwayCashBox.Controllers
{
	[Authorize(Roles = "admin")]
	public class ManagersController : Controller
	{
        private Repository db = new Repository();

		public ActionResult Index()
		{
			var managers = db.GetManagers().Select(m => new SecurityAccount() {UserId = m.Id, UserName = m.UserName});
			return View(managers);
		}

		public ActionResult Create()
		{
			return View(new SecurityAccount());
		}

		[HttpPost]
		public ActionResult Create(SecurityAccount securityAccount)
		{
			db.AddManager(securityAccount.UserName, securityAccount.Password);
			return RedirectToAction("Index");
		}

		public ActionResult Edit(string id)
		{
			var manager = db.GetManager(id);
			return View(new SecurityAccount {UserId = manager.Id, UserName = manager.UserName});
		}

		[HttpPost]
		public ActionResult Edit(SecurityAccount securityAccount)
		{
			db.SaveManager(securityAccount.UserId, securityAccount.UserName);
			return RedirectToAction("Index");
		}

		public ActionResult ChangePassword(string id)
		{
			var manager = db.GetManager(id);
			return View(new SecurityAccount { UserId = manager.Id, UserName = manager.UserName });
		}

		[HttpPost]
		public ActionResult ChangePassword(SecurityAccount securityAccount)
		{
			db.ChangePassword(securityAccount.UserId, securityAccount.Password);
			return RedirectToAction("Index");
		}

		public ActionResult Delete(string id)
		{
			var manager = db.GetManager(id);
			return View(new SecurityAccount { UserId = manager.Id, UserName = manager.UserName });
		}

		[HttpPost]
		public ActionResult Delete(SecurityAccount account)
		{
			db.DeleteUser(account.UserId);
			return RedirectToAction("Index");
		}

		protected override void Dispose(bool disposing)
		{
			db.Dispose();
			base.Dispose(disposing);
		}
	}
}

RailwayCashBox/Controllers/StationController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using RailwayCashBox.DAL.Entities;
using RailwayCashBox.DAL.Repositories;

namespace RailwayCashBox.Controllers
{
	[Authorize(Roles = "manager, admin")]
	public class StationController : Controller
    {
        private Repository db = new Repository();

        public ActionResult Index()
        {
            return View(db.GetAllStations());
        }

		public ActionResult Details(int id = 0)
        {
            Station station = db.GetStation(id);
            if (station == null)
            {
                return HttpNotFound();
            }
            return View(station);
        }

		public ActionResult Create()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Station station)
        {
            if (ModelState.IsValid)
            {
                db.CreateStation(station);

                return RedirectToAction("Index");
            }

            return View(station);
        }

		public ActionResult Edit(int id = 0)
		{
			Station station = db.GetStation(id);
			if (station == null)
			{
				return HttpNotFound();
			}
			return View(station);
		}

		[HttpPost]
		[ValidateAntiForgeryToken]
		public ActionResult Edit(Station station)
		{
			if (ModelState.IsValid)
			{
				db.EditStations(station);
				return RedirectToAction("Index");
			}
			return View(station);
		}

		public ActionResult Delete(int id = 0)
        {
            return View(db.GetStation(id));
        }

        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id, Station station)
        {
            try
            {
                db.DeleteStation(id);
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

		protected override void Dispose(bool disposing)
		{
			db.Dispose();
			base.Dispose(disposing);
		}
	}
}

RailwayCashBox/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Железнодорожная касса</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")

</head>
<body>
    <div class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                @Html.ActionLink("Железнодорожная касса", "Index", "Home", new { area = "" }, new { @class = "navbar-brand" })
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    @if (Request.IsAuthenticated)
                    {
                        if (User.IsInRole("manager") || User.IsInRole("admin"))
                        {
                            <li>@Html.ActionLink("Станции", "Index", "Station")</li>
                            <li>@Html.ActionLink("Маршруты", "Index", "TrainRoute")</li>
                        }
                        if (User.IsInRole("user"))
                        {
                            <li>@Html.ActionLink("Бронировки", "Orders", "Booking")</li>
                        }
                        if (User.IsInRole("admin"))
                        {
                            <li>@Html.ActionLink("Менеджеры", "Index", "Managers")</li>
                        }
                    }
                </ul>
                @Html.Partial("_LoginPartial")
            </div>
        </div>
    </div>
    <div class="container body-content">
        @RenderBody()
        <hr />
       
    </div>
    <footer class="_footer container">
        <p>&copy; @DateTime.Now.Year - Железнодорожная касса</p>
    </footer>
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap")

    <script>
        $(function() {
            $.datepicker.regional['ru'] = {
                closeText: 'Закрыть',
                prevText: '<Пред',
                nextText: 'След>',
                currentText: 'Сегодня',
                monthNames: [
                    'Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь',
                    'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь'
                ],
                monthNamesShort: [
                    'Янв', 'Фев', 'Мар', 'Апр', 'Май', 'Июн',
                    'Июл', 'Авг', 'Сен', 'Окт', 'Ноя', 'Дек'
                ],
                dayNames: ['воскресенье', 'понедельник', 'вторник', 'среда', 'четверг', 'пятница', 'суббота'],
                dayNamesShort: ['вск', 'пнд', 'втр', 'срд', 'чтв', 'птн', 'сбт'],
                dayNamesMin: ['Вс', 'Пн', 'Вт', 'Ср', 'Чт', 'Пт', 'Сб'],
                weekHeader: 'Не',
                dateFormat: 'mm/dd/yy',
                firstDay: 1,
                isRTL: false,
                showMonthAfterYear: false,
                yearSuffix: ''
            };
            $.datepicker.setDefaults($.datepicker.regional['ru']);


            $.timepicker.regional['ru'] = {
                timeOnlyTitle: 'Выберите время',
                timeText: 'Время',
                hourText: 'Часы',
                minuteText: 'Минуты',
                secondText: 'Секунды',
                millisecText: 'Миллисекунды',
                timezoneText: 'Часовой пояс',
                currentText: 'Сейчас',
                closeText: 'Закрыть',
                timeFormat: 'HH:mm',
                amNames: ['AM', 'A'],
                pmNames: ['PM', 'P'],
                isRTL: false
            };
            $.timepicker.setDefaults($.timepicker.regional['ru']);

            $('.datepicker').datepicker();
            $('.datetimepicker').datetimepicker();
        })
    </script>

    @RenderSection("scripts", false)
</body>
</html>